# 🎓 The Ultimate DevOps Course (early access 🚧)

This course is my ultimate guide to DevOps,SRE & platform engineering for beginners </br>

<i>🚧 This course is currently under early access and undergoing constant review and updates</i>

## 🚀 Introduction

In my many years working in the field, I have noticed a range of challenges and problems that people face when trying to start a DevOps, SRE, platform or cloud engineering career. </br>

## 🔴The current challenges of careers in Tech - <i>where to start ?</i>

 <b>DevOps has its challenges:</b>
* There is no simple starting point to start learning about DevOps
* DevOps requires a very broad range of skills that can be very overwhelming for new people to learn
* DevOps is often treated as "Dev" and "Ops" which means you need understanding of two broad fields
* DevOps technologies are littered with buzz words, such as cloud, AI, machine learning, CI/CD, scalability, immutable infrastructure, automation, security and it never ends

<b>Qualifications have its challenges:</b>

* Universities or Colleges offer IT degrees or courses, which often only cover traditional & "legacy" IT knowledge.
* They do not cover real world challenges faced when working with the cloud, or working with popular open source technologies or modern challenges that businesses face these days
* These technologies are often evolving at a rapid pace and traditional Universities cannot keep up with these.

<b>Cloud certifications have its challenges:</b>
* Cloud certifications often only focus on a specific cloud provider which can build bias
* Often only solve really specific problems, and miss real world problems
* Develop very narrow focussed problem solving skill
* Miss out on powerful open source skills
* Vendor locking 

## 🎯 Course Goals & Expectations

This course provides a practical hands-on roadmap into the world of DevOps, SRE and platform engineering. </br> 
It will set you up with all the fundamentals required for successful future learning. </br>
During this course you will apply a wide range of DevOps principles and use modern technologies in a real world hands-on manner to create yourself a personal website. </br> 
While building your website, we will cover topics such as:
* Source Control
* Developer Tools
* Operating Systems
* Servers & Virtualization
* Web technology
* Monitoring, Logging, Metrics
* Observability
* Command line and automation scripting
* CI / CD Pipelines
* Infrastructure as Code
* Basics of Cloud 
* Cloud deployments 

The personal website created throughout this course will become your marketing tool for your career to demonstrate all your newly obtained above-mentioned skills and abilities.</br>
You will build the ultimate foundation and be equipped to make more informed decisions on what you want to focus on next in your career. </br>

## 🛠 System Requirements

* <b>Operating System:</b> Windows (Pro and Enterprise ), Linux or MacOS
  * <i>note: You'll need Pro or Enterprise Windows to support Virtualization</i>

* You will need at least 8GB RAM and 20GB of hard disk space to complete modules related to virtualization. </br>
  * <i>These numbers are early access guide only and may be reviewed and adjusted based on course feedback</i>

## 📖 Table of Contents 

* [Chapter 1: Source Control & GIT](./chapters/chapter-1-source-control-git/README.md)
* 🚧[Chapter 2: Operating Systems](./chapters/chapter-2-operating-systems/README.md)
* 🚧[Chapter 3: Monitoring](./chapters/chapter-3-monitoring/README.md)
* 🚧[Chapter 4: Web Servers](./chapters/chapter-4-web-servers/README.md)
* 🚧[Chapter 4.1: Web Server Monitoring](./chapters/chapter-4.1-web-server-monitoring/README.md)
* 🚧[Chapter 5: CI/CD Pipelines](./chapters/chapter-5-ci-cd-pipelines/README.md)
* 🚧[Chapter 6: Containers & Docker](./chapters/chapter-6-docker/README.md)
* 🚧[Chapter 7: Docker Compose ](./chapters/chapter-7-docker-compose/README.md)
* 🚧[Chapter 8: Infrastructure as Code ](./chapters/chapter-8-infra-as-code/README.md)
* 🚧[Chapter 9: Introduction to Cloud ](./chapters/chapter-9-intro-to-cloud/README.md)

## 📖 Where to find the full course

The course will have a free summarised and editted version which touches on each topic for you to get started so you can benefit from the roadmap </br>

However, the YouTube videos are in shorter, edited, summarised form. So although you may benefit from the content, if you are a beginner, you may prefer the long form content where I elaborate, provider more in-depth explanations and cover more examples </br>
The paid course will also provide some bonus content </br>

If you are a beginner, I highly recommend you checkout the full course on your favourite platform below:

* 🚧Coming soon [Udemy ]()
* 🚧Coming soon [Teachables ]()
* 🚧Coming soon [Youtube Membership ]()
* 🚧Coming soon [Patreon ]()

## Explore the Course

![](course-diagram.svg)
